Home | History | Annotate | Download | only in buildit
      1 #!/bin/sh
      2 # LLVM LOCAL file B&I
      3 
      4 set -x
      5 
      6 # Build LLVM the "Apple way".
      7 # Parameters:
      8 
      9 # The first parameter is a space-separated list of the architectures the
     10 # compilers will run on. For instance, "ppc i386". If the current machine
     11 # isn't in the list, it will (effectively) be added.
     12 HOSTS="$1"
     13 
     14 # The second parameter is a space-separated list of the architectures the
     15 # compilers will generate code for. If the current machine isn't in the list, a
     16 # compiler for it will get built anyway, but won't be installed.
     17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
     18 TARGETS="$2"
     19 
     20 # The third parameter is the path to the compiler sources. There should be a
     21 # shell script named 'configure' in this directory. This script makes a copy...
     22 ORIG_SRC_DIR="$3"
     23 
     24 # The fourth parameter is the location where the LLVM will be installed. You can
     25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
     26 DEST_ROOT="$4"
     27 
     28 # The fifth parameter is the place where the compiler will be copied once it's
     29 # built.
     30 DEST_DIR="$5"
     31 
     32 # The sixth parameter is a directory in which to place information (like
     33 # unstripped executables and generated source files) helpful in debugging the
     34 # resulting compiler.
     35 SYM_DIR="$6"
     36 
     37 # The seventh parameter is a yes/no that indicates whether assertions should be
     38 # enabled in the LLVM libs/tools.
     39 LLVM_ASSERTIONS="$7"
     40 
     41 # The eighth parameter is a yes/no that indicates whether this is an optimized
     42 # build.
     43 LLVM_OPTIMIZED="$8"
     44 
     45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
     46 # should be installed.
     47 INSTALL_LIBLTO="$9"
     48 
     49 # A yes/no parameter that controls whether to cross-build for an ARM host.
     50 ARM_HOSTED_BUILD="${10}"
     51 
     52 # A yes/no parameter that controls whether to cross-build for the iOS simulator
     53 IOS_SIM_BUILD="${11}"
     54 
     55 # The version number of the submission, e.g. 1007.
     56 LLVM_SUBMIT_VERSION="${12}"
     57 
     58 # The subversion number of the submission, e.g. 03.
     59 LLVM_SUBMIT_SUBVERSION="${13}"
     60 
     61 # The current working directory is where the build will happen. It may already
     62 # contain a partial result of an interrupted build, in which case this script
     63 # will continue where it left off.
     64 DIR=`pwd`
     65 
     66 DARWIN_VERS=`uname -r | sed 's/\..*//'`
     67 echo DARWIN_VERS = $DARWIN_VERS
     68 
     69 ################################################################################
     70 # Run the build.
     71 
     72 # Create the source tree we'll actually use to build, deleting
     73 # tcl since it doesn't actually build properly in a cross environment
     74 # and we don't really need it.
     75 SRC_DIR=$DIR/src
     76 rm -rf $SRC_DIR || exit 1
     77 mkdir $SRC_DIR || exit 1
     78 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
     79 # We can't use the top-level Makefile as-is.  Remove the soft link:
     80 rm $SRC_DIR/Makefile || exit 1
     81 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
     82 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
     83 
     84 # Build the LLVM tree universal.
     85 mkdir -p $DIR/obj-llvm || exit 1
     86 cd $DIR/obj-llvm || exit 1
     87 
     88 if [ "$ARM_HOSTED_BUILD" = yes ]; then
     89   # The cross-tools' build process expects to find an existing cross toolchain
     90   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
     91   rm -rf $DIR/bin || exit 1
     92   mkdir $DIR/bin || exit 1
     93   for prog in ar nm ranlib strip lipo ld as ; do
     94     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
     95     T=`xcrun -sdk $SDKROOT -find ${prog}`
     96     echo '#!/bin/sh' > $P || exit 1
     97     echo 'exec '$T' "$@"' >> $P || exit 1
     98     chmod a+x $P || exit 1
     99   done
    100   # Try to use the platform llvm-gcc. Fall back to gcc if it's not available.
    101   for prog in gcc g++ ; do
    102     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
    103     T=`xcrun -sdk $SDKROOT -find llvm-${prog}`
    104     if [ "x$T" = "x" ] ; then
    105       T=`xcrun -sdk $SDKROOT -find ${prog}`
    106     fi
    107     echo '#!/bin/sh' > $P || exit 1
    108     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
    109     chmod a+x $P || exit 1
    110   done
    111 
    112   PATH=$DIR/bin:$PATH
    113 # otherwise, try to use llvm-gcc if it's available
    114 elif [ $DARWIN_VERS -gt 9 ]; then
    115   # If the user has set CC or CXX, respect their wishes.  If not,
    116   # compile with LLVM-GCC/LLVM-G++ if available; if LLVM is not
    117   # available, fall back to usual GCC/G++ default.
    118   savedPATH=$PATH ; PATH="/Developer/usr/bin:$PATH"
    119   XTMPCC=$(which llvm-gcc)
    120   if [ x$CC  = x -a x$XTMPCC != x ] ; then export CC=$XTMPCC  ; fi
    121   XTMPCC=$(which llvm-g++)
    122   if [ x$CXX = x -a x$XTMPCC != x ] ; then export CXX=$XTMPCC ; fi
    123   PATH=$savedPATH
    124   unset XTMPCC savedPATH
    125 fi
    126 
    127 if [ "$ARM_HOSTED_BUILD" = yes ]; then
    128   configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
    129                   --target=arm-apple-darwin10 --build=i686-apple-darwin10"
    130 elif [ "$IOS_SIM_BUILD" = yes ]; then
    131   # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
    132   configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
    133                   --build=i686-apple-darwin10"
    134 else
    135   configure_opts="--enable-targets=arm,x86,cbe"
    136 fi
    137 
    138 if [ \! -f Makefile.config ]; then
    139   $SRC_DIR/configure --prefix=$DEST_DIR$DEST_ROOT $configure_opts \
    140     --enable-assertions=$LLVM_ASSERTIONS \
    141     --enable-optimized=$LLVM_OPTIMIZED \
    142     --disable-bindings \
    143     || exit 1
    144 fi
    145 
    146 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
    147 
    148 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
    149     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
    150     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
    151     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
    152 fi
    153 
    154 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
    155     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
    156 else
    157     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
    158 fi
    159 
    160 GCC_VER=`cc --version 2>/dev/null | sed 1q`
    161 
    162 if echo "$GCC_VER" | grep GCC > /dev/null; then
    163     GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
    164     MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
    165     MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
    166 fi
    167 
    168 JOBS_FLAG=""
    169 
    170 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
    171 # already has parallelism and we don't want to make the builders hit swap by
    172 # firing off too many gccs at the same time.
    173 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
    174     # Figure out how many make processes to run.
    175     SYSCTL=`sysctl -n hw.activecpu`
    176 
    177     # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
    178     # Builders can default to 2, since even if they are single processor,
    179     # nothing else is running on the machine.
    180     if [ -z "$SYSCTL" ]; then
    181         SYSCTL=2
    182     fi
    183 
    184     JOBS_FLAG="-j $SYSCTL"
    185 fi
    186 
    187 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
    188     UNIVERSAL_SDK_PATH=$SDKROOT \
    189     NO_RUNTIME_LIBS=1 \
    190     DISABLE_EDIS=1 \
    191     DEBUG_SYMBOLS=1 \
    192     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
    193     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
    194     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
    195     VERBOSE=1
    196 
    197 if [ $? != 0 ] ; then
    198     echo "error: LLVM 'make' failed!"
    199     exit 1
    200 fi 
    201 
    202 ################################################################################
    203 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
    204 # $DEST_DIR, with occasional 'lipo' commands.
    205 
    206 cd $DEST_DIR || exit 1
    207 
    208 # Clean out DEST_DIR in case -noclean was passed to buildit.
    209 rm -rf * || exit 1
    210 
    211 cd $DIR/obj-llvm || exit 1
    212 
    213 # Install the tree into the destination directory.
    214 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
    215     NO_RUNTIME_LIBS=1 \
    216     DISABLE_EDIS=1 \
    217     DEBUG_SYMBOLS=1 \
    218     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
    219     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
    220     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
    221 
    222 if ! test $? == 0 ; then
    223     echo "error: LLVM 'make install' failed!"
    224     exit 1
    225 fi 
    226 
    227 # Install Version.h
    228 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
    229 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
    230     LLVM_MINOR_VERSION=0
    231 fi
    232 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
    233 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
    234 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
    235 
    236 if [ "x$LLVM_DEBUG" != "x1" ]; then
    237     # Strip local symbols from llvm libraries.
    238     #
    239     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
    240     # PPC objects!
    241     strip -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
    242     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
    243         strip -Sxl $f
    244     done
    245 fi
    246 
    247 # Copy over the tblgen utility.
    248 cp `find $DIR -name tblgen` $DEST_DIR$DEST_ROOT/bin
    249 
    250 # Remove .dir files 
    251 cd $DEST_DIR$DEST_ROOT
    252 rm -f bin/.dir etc/llvm/.dir lib/.dir
    253 
    254 # Remove PPC64 fat slices.
    255 cd $DEST_DIR$DEST_ROOT/bin
    256 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
    257     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
    258         -exec lipo -extract ppc -extract i386 {} -output {} \;
    259 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
    260     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
    261         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
    262 else
    263     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
    264         -exec lipo -extract i386 -extract x86_64 {} -output {} \;
    265 fi
    266 
    267 # The Hello dylib is an example of how to build a pass.
    268 # The BugpointPasses module is only used to test bugpoint.
    269 # These unversioned dylibs cause verification failures, so do not install them.
    270 # (The wildcards are used to match a "lib" prefix if it is present.)
    271 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
    272 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
    273 
    274 # Compress manpages
    275 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
    276 gzip -f $MDIR/*
    277 
    278 ################################################################################
    279 # Create SYM_DIR with information required for debugging.
    280 
    281 # Figure out how many make processes to run.
    282 SYSCTL=`sysctl -n hw.activecpu`
    283 
    284 # hw.activecpu only available in 10.2.6 and later
    285 if [ -z "$SYSCTL" ]; then
    286   SYSCTL=`sysctl -n hw.ncpu`
    287 fi
    288 
    289 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
    290 # can default to 2, since even if they are single processor, nothing else is
    291 # running on the machine.
    292 if [ -z "$SYSCTL" ]; then
    293   SYSCTL=2
    294 fi
    295 
    296 cd $SYM_DIR || exit 1
    297 
    298 # Clean out SYM_DIR in case -noclean was passed to buildit.
    299 rm -rf * || exit 1
    300 
    301 # Generate .dSYM files
    302 find $DEST_DIR -perm -0111 -type f \
    303     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
    304     -print | xargs -n 1 -P ${SYSCTL} dsymutil
    305 
    306 # Save .dSYM files and .a archives
    307 cd $DEST_DIR || exit 1
    308 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
    309     | cpio -pdml $SYM_DIR || exit 1
    310 
    311 # Save source files.
    312 mkdir $SYM_DIR/src || exit 1
    313 cd $DIR || exit 1
    314 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
    315     | cpio -pdml $SYM_DIR/src || exit 1
    316 
    317 ################################################################################
    318 # Install and strip libLTO.dylib
    319 
    320 cd $DEST_DIR$DEST_ROOT
    321 if [ "$INSTALL_LIBLTO" = "yes" ]; then
    322   DT_HOME="$DEST_DIR/Developer/usr"
    323   mkdir -p $DT_HOME/lib
    324   mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
    325 
    326   # Save a copy of the unstripped dylib
    327   mkdir -p $SYM_DIR/Developer/usr/lib
    328   cp $DT_HOME/lib/libLTO.dylib $SYM_DIR/Developer/usr/lib/libLTO.dylib
    329 
    330   # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
    331   # PPC objects!
    332   strip -arch all -Sl $DT_HOME/lib/libLTO.dylib
    333 
    334   if [ "x$DISABLE_USR_LINKS" == "x" ]; then
    335     # Add a symlink in /usr/lib for B&I.
    336     mkdir -p $DEST_DIR/usr/lib/
    337     (cd $DEST_DIR/usr/lib && \
    338       ln -s ../../Developer/usr/lib/libLTO.dylib ./libLTO.dylib)
    339   fi
    340 else
    341   rm -f lib/libLTO.dylib
    342 fi
    343 rm -f lib/libLTO.a lib/libLTO.la
    344 
    345 # Omit lto.h from the result.  Clang will supply.
    346 find $DEST_DIR$DEST_ROOT -name lto.h -delete
    347 
    348 ################################################################################
    349 # Remove debugging information from DEST_DIR.
    350 
    351 cd $DIR || exit 1
    352 
    353 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
    354 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
    355 
    356 # Strip debugging information from files
    357 #
    358 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
    359 # PPC objects!
    360 find $DEST_DIR -perm -0111 -type f \
    361     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
    362     -print | xargs -n 1 -P ${SYSCTL} strip -arch all -Sl
    363 
    364 chgrp -h -R wheel $DEST_DIR
    365 chgrp -R wheel $DEST_DIR
    366 
    367 ################################################################################
    368 # Remove the docs directory
    369 
    370 rm -rf $DEST_DIR$DEST_ROOT/docs
    371 
    372 ################################################################################
    373 # w00t! Done!
    374 
    375 exit 0
    376